//
//  ConversationsNodePresenter.swift
//  VKExt
//
//  Created programmist_NA on 24.07.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import RealmSwift
import Reachability
import SwiftyVK

class ConversationsNodePresenter: ConversationsNodePresenterProtocol {

    weak private var view: ConversationsNodeViewProtocol?
    var interactor: ConversationsNodeInteractorProtocol?
    private let router: ConversationsNodeWireframeProtocol
    let realm = try! Realm()
    let reachability = Reachability()

    init(interface: ConversationsNodeViewProtocol, interactor: ConversationsNodeInteractorProtocol?, router: ConversationsNodeWireframeProtocol) {
        self.view = interface
        self.interactor = interactor
        self.router = router
    }

    func start() {
        guard let interactor = self.interactor else { return }
        interactor.start()
    }
    
    // Действие при событии
    func onEvent(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.1, execute: {
            self.view?.showStatusError(message: message, error: nil, style, with: false)
        })
    }
    
    // Обработка ошибки
    func onHandleError(error: VKError) {
        switch error {
        case .unknown(let error):
            DispatchQueue.main.async {
                self.view?.showStatusError(message: error.localizedDescription, error: nil, .error, with: false)
            }
        case .api(let apiError):
            DispatchQueue.main.async {
                self.view?.showStatusError(message: apiError.message, error: nil, .error, with: false)
            }
        default:
            break
        }
    }
    
    // Обработка нажатия на диалог
    func onTapConversation(at conversation: Conversation) {
        router.openConversation(from: conversation)
    }
    
    func onTapPerformProfile(userId: Int) {
        router.openProfile(userId: userId)
    }
    
    // Обработка смены режима уведомлений
    func onChangeSilenceMode(peerId: Int, sound: Int) {
        guard let interactor = interactor else { return }
        interactor.setSilenceMode(peerId: peerId, sound: sound)
    }
    
    // Oбработка удаления диалога
    func onDeleteConversation(peerId: Int) {
        guard let interactor = interactor else { return }
        interactor.deleteConversation(peerId: peerId)
    }
    
    // Обработка действия "Прочитать сообщение"
    func onTapReadConversation(with peerId: Int) {
        guard let interactor = interactor else { return }
        interactor.readMessage(peerId: peerId)
    }
    
    // Обработка действия "Отметить сообщение непрочитанным"
    func onTapUnreadConversation(with peerId: Int) {
        guard let interactor = interactor else { return }
        interactor.markAsUnreadConversation(peerId: peerId)
    }
}
